%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 1
%global version_minor 15
%global version_micro 9
%global serial 28
%global commitid 8d9e79a2df461c74112976fbc33bc3210a1ab32b

%define with_src_zip 1


%{?scl:%scl_package mod_http2}
%{!?scl:%global pkg_name %{name}}
%define scldir /opt/rh/jbcs-httpd24/root

Name:		%{?scl_prefix}mod_http2
Version:	1.15.19
Release:	%{serial}%{?dist}
Summary:	module implementing HTTP/2 for Apache 2
Group:		System Environment/Daemons
License:	ASL 2.0
URL:		https://icing.github.io/mod_h2/
Source0:	%{pkg_name}-%{commitid}.tar.gz


BuildRequires: gcc, make, autoconf, automake, libtool
BuildRequires: pkgconfig, zip
BuildRequires: %{?scl_prefix}apr-devel
BuildRequires: %{?scl_prefix}apr-util-devel
BuildRequires: %{?scl_prefix}httpd-devel
BuildRequires: %{?scl_prefix}openssl-devel
BuildRequires: %{?scl_prefix}nghttp2-devel
BuildRequires: %{?scl_prefix}libcurl-devel

BuildRequires: %{?scl_prefix}httpd
BuildRequires: %{?scl_prefix}openssl
BuildRequires: %{?scl_prefix}nghttp2
BuildRequires: %{?scl_prefix}libcurl

Requires: %{?scl_prefix}httpd
Requires: %{?scl_prefix}apr
Requires: %{?scl_prefix}apr-util
Requires: %{?scl_prefix}openssl
Requires: %{?scl_prefix}nghttp2
Requires: %{?scl_prefix}libcurl

# Excludes libnghttp2.so.* from Requires, since the devel package already Requires jbcs-httpd24-nghttp2
%global __requires_exclude ^(libnghttp2[.]so.*)$

%description
The mod_h2 Apache httpd module implements the HTTP2 protocol (h2+h2c) on
top of libnghttp2 for httpd 2.4 servers.

%if %{with_src_zip}
%package src-zip
Summary:     Container for the source distribution of %{pkg_name}
Group:       Development

%description src-zip
Container for the source distribution of %{pkg_name}.
%endif

%prep
%setup -q -n %{pkg_name}-%{commitid}

# Rewrite release number
sed -i "s;-git;-%{serial};g" mod_http2/h2_version.h.in

%build
autoreconf --force --install -I m4
automake
autoconf

%if %{with_src_zip}
zip -q -r %{name}-%{version}-src.zip *
%endif

export LDFLAGS="-L%{_libdir} -Wl,-rpath=%{_libdir} -Wl,-z,relro,-z,now"
export CFLAGS="-fPIC -g"
export CPPFLAGS="-I%{scldir}/usr/include"

./configure --with-apxs=%{_sbindir}/apxs
make %{?_smp_mflags} V=1

%install
%if %{with_src_zip}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
%{__install} %{name}-%{version}-src.zip  ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

make DESTDIR=%{buildroot} install
rm -rf %{buildroot}%{scldir}/etc/httpd/share/doc/

# create configuration
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.modules.d
echo "LoadModule http2_module modules/mod_http2.so" > %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/10-h2.conf
echo "LoadModule proxy_http2_module modules/mod_proxy_http2.so" > %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/10-proxy_h2.conf

%files
%doc README README.md ChangeLog AUTHORS LICENSE
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/10-h2.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/10-proxy_h2.conf
%{_libdir}/httpd/modules/mod_http2.so
%{_libdir}/httpd/modules/mod_proxy_http2.so

%if %{with_src_zip}
%files src-zip
%defattr(0644,root,root,0755)
%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

%changelog
* Wed Jun 21 2023 Mladen Turk <mturk@redhat.com> - 1.15.9-24
- Rebuild for httpd-2.4.57

* Wed May 10 2023 cpaas-ops <cpaas-ops@redhat.com> - 1.15.19-23
- Built by CPaaS

* Wed Apr 26 2023 Mladen Turk <mturk@redhat.com> - 1.15.9-21
- Apply CVE-2023-25690 patch

* Mon Nov 07 2022 cpaas-ops <cpaas-ops@redhat.com> - 1.15.19-20
- Built by CPaaS

* Mon Nov 07 2022 cpaas-ops <cpaas-ops@redhat.com> - 1.15.19-19
- Built by CPaaS

* Sun Nov 06 2022 cpaas-ops <cpaas-ops@redhat.com> - 1.15.19-18
- Built by CPaaS

* Wed Sep 14 2022 cpaas-ops <cpaas-ops@redhat.com> - 1.15.19-17
- Built by CPaaS

* Wed Mar 23 2022 Mladen Turk <mturk@redhat.com> - 1.15.9-7
- Apply mod_http2-1.15.19-CVE-2021-44224 patch

* Wed Feb 09 2022 Mladen Turk <mturk@redhat.com> - 1.15.9-1
- Use sources from rhel-9.0.0 branch

* Fri Oct 09 2020 George Zaronikas <gzaronik@redhat.com> - 1.15.7-8
- Adding fix for JBCS-990 CVE-2019-1551

* Mon Mar 16 2020 George Zaronikas <gzaronik@redhat.com> - 1.11.3-19
Fixes for JBCS-851 JBCS-853 CVE-2019-10081 CVE-2019-10082

* Tue Dec 17 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.11.3-8
- JBCS 2.4.37-SP1.ER1

* Mon Dec 16 2019 Mladen Turk <mturk@redhat.com> - 1.11.3-7
- Rebuild for jbcs with updated commitid

* Tue Dec 10 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.11.3-6
- Creating src-zip rpm

* Wed Dec 04 2019 Mladen Turk <mturk@redhat.com> - 1.11.3-4
- Rebuild for jbcs

* Thu Aug 29 2019 Lubos Uhliarik <luhliari@redhat.com> - 1.11.3-3
- Resolves: #1744999 - CVE-2019-9511 httpd:2.4/mod_http2: HTTP/2: large amount
  of data request leads to denial of service
- Resolves: #1745086 - CVE-2019-9516 httpd:2.4/mod_http2: HTTP/2: 0-length
  headers leads to denial of service
- Resolves: #1745154 - CVE-2019-9517 httpd:2.4/mod_http2: HTTP/2: request for
  large response leads to denial of service

* Thu Apr  4 2019 Joe Orton <jorton@redhat.com> - 1.11.3-2
- update release (#1695587)

* Tue Oct 16 2018 Lubos Uhliarik <luhliari@redhat.com> - 1.11.3-1
- new version 1.11.3
- Resolves: #1633401 - CVE-2018-11763 mod_http2: httpd:  DoS for HTTP/2
  connections by continuous SETTINGS

* Wed May  2 2018 Joe Orton <jorton@redhat.com> - 1.10.20-1
- update to 1.10.20

* Wed Apr 18 2018 Joe Orton <jorton@redhat.com> - 1.10.18-1
- update to 1.10.18

* Thu Mar 29 2018 Joe Orton <jorton@redhat.com> - 1.10.16-1
- update to 1.10.16 (CVE-2018-1302)

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.10.13-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Nov  7 2017 Joe Orton <jorton@redhat.com> - 1.10.13-1
- update to 1.10.13

* Fri Oct 20 2017 Joe Orton <jorton@redhat.com> - 1.10.12-1
- update to 1.10.12

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.10.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Mon Jul 31 2017 Joe Orton <jorton@redhat.com> - 1.10.10-1
- update to 1.10.10

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.10.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Thu Jul  6 2017 Joe Orton <jorton@redhat.com> - 1.10.7-1
- update to 1.10.7

* Mon Jun 12 2017 Joe Orton <jorton@redhat.com> - 1.10.6-1
- update to 1.10.6

* Tue May 16 2017 Joe Orton <jorton@redhat.com> - 1.10.5-1
- update to 1.10.5

* Mon Apr 10 2017 Luboš Uhliarik <luhliari@redhat.com> - 1.10.1-1
- Initial import (#1440780).
